Index: src/mpi_mod.f90
===================================================================
--- src/mpi_mod.f90	(revision 0c8c7f2f1bd07179b6e1be5a302d9e2d52633f9e)
+++ src/mpi_mod.f90	(revision 0ecc1fed9f7c7c07cef687094373915d51c69489)
@@ -88,5 +88,4 @@
 ! Variables for MPI processes in the 'particle' group
   integer, allocatable, dimension(:) :: mp_partgroup_rank
-  integer, allocatable, dimension(:) :: npart_per_process
   integer :: mp_partgroup_comm, mp_partgroup_pid, mp_partgroup_np
 
@@ -126,5 +125,5 @@
 ! mp_time_barrier   Measure MPI barrier time
 ! mp_exact_numpart  Use an extra MPI communication to give the exact number of particles
-!                   to standard output (this does not otherwise affect the simulation)
+!                   to standard output (this does *not* otherwise affect the simulation) 
   logical, parameter :: mp_dbg_mode = .false.
   logical, parameter :: mp_dev_mode = .false.
@@ -191,6 +190,6 @@
 !   mp_np       number of running processes, decided at run-time
 !***********************************************************************
-    use par_mod, only: maxpart, numwfmem, dep_prec, maxreceptor, maxspec
-    use com_mod, only: mpi_mode, verbosity, creceptor0
+    use par_mod, only: maxpart, numwfmem, dep_prec
+    use com_mod, only: mpi_mode, verbosity
 
     implicit none
@@ -338,5 +337,5 @@
 
 ! Set maxpart per process
-! ESO 08/2016: Increase maxpart per process, in case of unbalanced distribution
+! eso 08/2016: Increase maxpart per process, in case of unbalanced distribution
     maxpart_mpi=int(mp_maxpart_factor*real(maxpart)/real(mp_partgroup_np))
     if (mp_np == 1) maxpart_mpi = maxpart
@@ -366,14 +365,4 @@
     end if
 
-! Allocate array for number of particles per process    
-    allocate(npart_per_process(0:mp_partgroup_np-1))
-
-! Write whether MPI_IN_PLACE is used or not
-#ifdef USE_MPIINPLACE
-    if (lroot) write(*,*) 'Using MPI_IN_PLACE operations'
-#else
-    if (lroot) allocate(creceptor0(maxreceptor,maxspec))
-    if (lroot) write(*,*) 'Not using MPI_IN_PLACE operations'
-#endif
     goto 101
 
@@ -570,5 +559,5 @@
 ! invalid particles at the end of the arrays
 
-601 do i=numpart, 1, -1
+601 do i=num_part, 1, -1
       if (itra1(i).eq.-999999999) then
         numpart=numpart-1
@@ -609,5 +598,5 @@
     integer :: i,jj,nn, num_part=1,m,imin, num_trans
     logical :: first_iter
-    integer,allocatable,dimension(:) :: idx_arr
+    integer,allocatable,dimension(:) :: numparticles_mpi, idx_arr
     real,allocatable,dimension(:) :: sorted ! TODO: we don't really need this
 
@@ -618,7 +607,8 @@
 ! All processes exchange information on number of particles
 !****************************************************************************
-    allocate( idx_arr(0:mp_partgroup_np-1), sorted(0:mp_partgroup_np-1))
-
-    call MPI_Allgather(numpart, 1, MPI_INTEGER, npart_per_process, &
+    allocate(numparticles_mpi(0:mp_partgroup_np-1), &
+         &idx_arr(0:mp_partgroup_np-1), sorted(0:mp_partgroup_np-1))
+
+    call MPI_Allgather(numpart, 1, MPI_INTEGER, numparticles_mpi, &
          & 1, MPI_INTEGER, mp_comm_used, mp_ierr)
 
@@ -626,11 +616,8 @@
 ! Sort from lowest to highest
 ! Initial guess: correct order
-    sorted(:) = npart_per_process(:)
+    sorted(:) = numparticles_mpi(:)
     do i=0, mp_partgroup_np-1
       idx_arr(i) = i
     end do
-
-! Do not rebalance particles for ipout=3    
-    if (ipout.eq.3) return
 
 ! For each successive element in index array, see if a lower value exists
@@ -658,11 +645,11 @@
     m=mp_partgroup_np-1 ! index for last sorted process (most particles)
     do i=0,mp_partgroup_np/2-1
-      num_trans = npart_per_process(idx_arr(m)) - npart_per_process(idx_arr(i))
+      num_trans = numparticles_mpi(idx_arr(m)) - numparticles_mpi(idx_arr(i))
       if (mp_partid.eq.idx_arr(m).or.mp_partid.eq.idx_arr(i)) then
-        if ( npart_per_process(idx_arr(m)).gt.mp_min_redist.and.&
-             & real(num_trans)/real(npart_per_process(idx_arr(m))).gt.mp_redist_fract) then
+        if ( numparticles_mpi(idx_arr(m)).gt.mp_min_redist.and.&
+             & real(num_trans)/real(numparticles_mpi(idx_arr(m))).gt.mp_redist_fract) then
 ! DBG
-          ! write(*,*) 'mp_partid, idx_arr(m), idx_arr(i), mp_min_redist, num_trans, npart_per_process', &
-          !      &mp_partid, idx_arr(m), idx_arr(i), mp_min_redist, num_trans, npart_per_process
+          ! write(*,*) 'mp_partid, idx_arr(m), idx_arr(i), mp_min_redist, num_trans, numparticles_mpi', &
+          !      &mp_partid, idx_arr(m), idx_arr(i), mp_min_redist, num_trans, numparticles_mpi
 ! DBG
           call mpif_redist_part(itime, idx_arr(m), idx_arr(i), num_trans/2)
@@ -672,5 +659,5 @@
     end do
 
-    deallocate(idx_arr, sorted)
+    deallocate(numparticles_mpi, idx_arr, sorted)
 
   end subroutine mpif_calculate_part_redist
@@ -1974,5 +1961,5 @@
     if (readclouds) then
       j=j+1
-      call MPI_Irecv(ctwc(:,:,mind),d2s1*5,mp_sp,id_read,MPI_ANY_TAG,&
+      call MPI_Irecv(ctwc(:,:,mind),d2s1,mp_sp,id_read,MPI_ANY_TAG,&
            &MPI_COMM_WORLD,reqs(j),mp_ierr)
       if (mp_ierr /= 0) goto 600
@@ -2339,5 +2326,5 @@
       if (readclouds) then
         j=j+1
-        call MPI_Irecv(ctwcn(:,:,mind,k),d2s1*5,mp_sp,id_read,MPI_ANY_TAG,&
+        call MPI_Irecv(ctwcn(:,:,mind,k),d2s1,mp_sp,id_read,MPI_ANY_TAG,&
              &MPI_COMM_WORLD,reqs(j),mp_ierr)
         if (mp_ierr /= 0) goto 600
@@ -2475,5 +2462,25 @@
     end if
 
-  ! Receptor concentrations    
+#else
+
+      call MPI_Reduce(gridunc, gridunc0, grid_size3d, mp_sp, MPI_SUM, id_root, &
+           & mp_comm_used, mp_ierr)
+      if (lroot) gridunc = gridunc0
+
+#endif
+
+    if ((WETDEP).and.(ldirect.gt.0)) then
+      call MPI_Reduce(wetgridunc, wetgridunc0, grid_size2d, mp_cp, MPI_SUM, id_root, &
+           & mp_comm_used, mp_ierr)
+      if (mp_ierr /= 0) goto 600
+    end if
+
+    if ((DRYDEP).and.(ldirect.gt.0)) then
+      call MPI_Reduce(drygridunc, drygridunc0, grid_size2d, mp_cp, MPI_SUM, id_root, &
+           & mp_comm_used, mp_ierr)
+      if (mp_ierr /= 0) goto 600
+    end if
+
+! Receptor concentrations    
     if (lroot) then
       call MPI_Reduce(MPI_IN_PLACE,creceptor,rcpt_size,mp_sp,MPI_SUM,id_root, &
@@ -2484,31 +2491,4 @@
            & mp_comm_used,mp_ierr)
     end if
-
-#else
-
-      call MPI_Reduce(gridunc, gridunc0, grid_size3d, mp_sp, MPI_SUM, id_root, &
-           & mp_comm_used, mp_ierr)
-      if (mp_ierr /= 0) goto 600
-      if (lroot) gridunc = gridunc0
-
-      call MPI_Reduce(creceptor, creceptor0,rcpt_size,mp_sp,MPI_SUM,id_root, &
-           & mp_comm_used,mp_ierr)
-      if (mp_ierr /= 0) goto 600
-      if (lroot) creceptor = creceptor0
-
-#endif
-
-    if ((WETDEP).and.(ldirect.gt.0)) then
-      call MPI_Reduce(wetgridunc, wetgridunc0, grid_size2d, mp_cp, MPI_SUM, id_root, &
-           & mp_comm_used, mp_ierr)
-      if (mp_ierr /= 0) goto 600
-    end if
-
-    if ((DRYDEP).and.(ldirect.gt.0)) then
-      call MPI_Reduce(drygridunc, drygridunc0, grid_size2d, mp_cp, MPI_SUM, id_root, &
-           & mp_comm_used, mp_ierr)
-      if (mp_ierr /= 0) goto 600
-    end if
-
 
     if (mp_measure_time) call mpif_mtime('commtime',1)
@@ -2720,17 +2700,17 @@
       end if
 
-   case ('readwind')
-     if (imode.eq.0) then
-       call cpu_time(mp_readwind_time_beg)
-       mp_readwind_wtime_beg = mpi_wtime()
-     else
-       call cpu_time(mp_readwind_time_end)
-       mp_readwind_wtime_end = mpi_wtime()
-
-       mp_readwind_time_total = mp_readwind_time_total + &
-            &(mp_readwind_time_end - mp_readwind_time_beg)
-       mp_readwind_wtime_total = mp_readwind_wtime_total + &
-            &(mp_readwind_wtime_end - mp_readwind_wtime_beg)
-     end if
+    case ('readwind')
+      if (imode.eq.0) then
+        call cpu_time(mp_readwind_time_beg)
+        mp_readwind_wtime_beg = mpi_wtime()
+      else
+        call cpu_time(mp_readwind_time_end)
+        mp_readwind_wtime_end = mpi_wtime()
+
+        mp_readwind_time_total = mp_readwind_time_total + &
+             &(mp_readwind_time_end - mp_readwind_time_beg)
+        mp_readwind_wtime_total = mp_readwind_wtime_total + &
+             &(mp_readwind_wtime_end - mp_readwind_wtime_beg)
+      end if
 
     case ('commtime')
@@ -2808,8 +2788,8 @@
           write(*,FMT='(A60,TR1,F9.2)') 'TOTAL CPU TIME FOR GETFIELDS:',&
                & mp_getfields_time_total
-!          write(*,FMT='(A60,TR1,F9.2)') 'TOTAL WALL TIME FOR READWIND:',&
-!               & mp_readwind_wtime_total
-!          write(*,FMT='(A60,TR1,F9.2)') 'TOTAL CPU TIME FOR READWIND:',&
-!               & mp_readwind_time_total
+          write(*,FMT='(A60,TR1,F9.2)') 'TOTAL WALL TIME FOR READWIND:',&
+               & mp_readwind_wtime_total
+          write(*,FMT='(A60,TR1,F9.2)') 'TOTAL CPU TIME FOR READWIND:',&
+               & mp_readwind_time_total
           write(*,FMT='(A60,TR1,F9.2)') 'TOTAL WALL TIME FOR FILE IO:',&
                & mp_io_wtime_total
Index: src/netcdf_output_mod.f90
===================================================================
--- src/netcdf_output_mod.f90	(revision 0a94e13d0d122caab219884890c29edcb2893c60)
+++ src/netcdf_output_mod.f90	(revision 4ad96c54b793af523a98633b88f07aa60c69ea47)
@@ -93,5 +93,5 @@
   character(len=255), parameter :: institution = 'NILU'
 
-  integer            :: tpointer=0
+  integer            :: tpointer
   character(len=255) :: ncfname, ncfnamen
 
Index: src/outg_mod.f90
===================================================================
--- src/outg_mod.f90	(revision 2eefa58ac797f119acc28fade41beff352006040)
+++ src/outg_mod.f90	(revision 4c64400c622119505b289ef83be130b0b81b9590)
@@ -37,6 +37,4 @@
   real,allocatable, dimension (:,:,:) :: areanorth
   real,allocatable, dimension (:,:,:) :: densityoutgrid
-  real,allocatable, dimension (:,:,:) :: densitydrygrid ! added RLT 
-  real,allocatable, dimension (:,:,:) :: factor_drygrid ! added RLT 
   real,allocatable, dimension (:,:,:) :: factor3d
   real,allocatable, dimension (:,:,:) :: grid
Index: src/outgrid_init.f90
===================================================================
--- src/outgrid_init.f90	(revision 2eefa58ac797f119acc28fade41beff352006040)
+++ src/outgrid_init.f90	(revision d2a5a833066965c4c4b33df109fd4e461f7275bb)
@@ -268,11 +268,4 @@
     if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
   allocate(densityoutgrid(0:max(numxgrid,numxgridn)-1, &
-       0:max(numygrid,numygridn)-1,numzgrid),stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
-! RLT
-  allocate(densitydrygrid(0:max(numxgrid,numxgridn)-1, &
-       0:max(numygrid,numygridn)-1,numzgrid),stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
-  allocate(factor_drygrid(0:max(numxgrid,numxgridn)-1, &
        0:max(numygrid,numygridn)-1,numzgrid),stat=stat)
     if (stat.ne.0) write(*,*)'ERROR: could not allocate gridunc'
Index: src/par_mod.f90
===================================================================
--- src/par_mod.f90	(revision 2eefa58ac797f119acc28fade41beff352006040)
+++ src/par_mod.f90	(revision 79e0349a50fd1ee6dfdf4b044ade2b6f1e702855)
@@ -30,4 +30,7 @@
 !        Update 15 August 2013 IP                                              *
 !                                                                              *
+!        ESO 2016:                                                             *
+!          GFS specific parameters moved to gfs_mod.f90                        *
+!          ECMWF specific parameters moved to ecmwf_mod.f90                    *
 !                                                                              *
 !*******************************************************************************
@@ -77,7 +80,4 @@
   real,parameter :: pi=3.14159265, r_earth=6.371e6, r_air=287.05, ga=9.81
   real,parameter :: cpa=1004.6, kappa=0.286, pi180=pi/180., vonkarman=0.4
-  ! additional constants RLT Aug-2017
-  real,parameter :: rgas=8.31447 
-  real,parameter :: r_water=461.495
 
   ! pi                      number "pi"
@@ -89,6 +89,4 @@
   ! kappa                   exponent of formula for potential temperature
   ! vonkarman               von Karman constant
-  ! rgas                    universal gas constant [J/mol/K]
-  ! r_water                 specific gas constant for water vapor [J/kg/K]
 
   real,parameter :: karman=0.40, href=15., convke=2.0
@@ -282,5 +280,5 @@
 
   integer,parameter :: unitpath=1, unitcommand=1, unitageclasses=1, unitgrid=1
-  integer,parameter :: unitavailab=1, unitreleases=88, unitpartout=93, unitpartout_average=105
+  integer,parameter :: unitavailab=1, unitreleases=88, unitpartout=93
   integer,parameter :: unitpartin=93, unitflux=98, unitouttraj=96
   integer,parameter :: unitvert=1, unitoro=1, unitpoin=1, unitreceptor=1
@@ -292,6 +290,4 @@
   integer,parameter :: unitboundcond=89
   integer,parameter :: unittmp=101
-! RLT
-  integer,parameter :: unitoutfactor=102
 
 !******************************************************
Index: src/partoutput.f90
===================================================================
--- src/partoutput.f90	(revision 0a94e13d0d122caab219884890c29edcb2893c60)
+++ src/partoutput.f90	(revision d2a5a833066965c4c4b33df109fd4e461f7275bb)
@@ -71,5 +71,5 @@
   !**************************************
 
-  if (ipout.eq.1.or.ipout.eq.3) then
+  if (ipout.eq.1) then
     open(unitpartout,file=path(2)(1:length(2))//'partposit_'//adate// &
          atime,form='unformatted')
Index: src/partoutput_mpi.f90
===================================================================
--- src/partoutput_mpi.f90	(revision 0a94e13d0d122caab219884890c29edcb2893c60)
+++ src/partoutput_mpi.f90	(revision d2a5a833066965c4c4b33df109fd4e461f7275bb)
@@ -78,5 +78,5 @@
   !**************************************
 
-  if (ipout.eq.1.or.ipout.eq.3) then
+  if (ipout.eq.1) then
     open(unitpartout,file=path(2)(1:length(2))//'partposit_'//adate// &
          atime,form='unformatted',status=file_stat,position='append')
Index: src/readcommand.f90
===================================================================
--- src/readcommand.f90	(revision 2eefa58ac797f119acc28fade41beff352006040)
+++ src/readcommand.f90	(revision 20963b15051b22eeb381dcf4e824a9104d92717b)
@@ -50,5 +50,4 @@
   ! ipin                 1 continue simulation with dumped particle data, 0 no *
   ! ipout                0 no particle dump, 1 every output time, 3 only at end*
-  ! ipoutfac             increase particle dump interval by factor (default 1) *
   ! itsplit [s]          time constant for particle splitting                  *
   ! loutaver [s]         concentration output is an average over loutaver      *
@@ -98,5 +97,4 @@
   iout, &
   ipout, &
-  ipoutfac, &
   lsubgrid, &
   lconvection, &
@@ -114,5 +112,4 @@
   surf_only, &
   cblflag, &
-  linversionout, &
   ohfields_path
 
@@ -132,5 +129,4 @@
   iout=3
   ipout=0
-  ipoutfac=1
   lsubgrid=1
   lconvection=1
@@ -148,5 +144,4 @@
   surf_only=0 
   cblflag=0 ! if using old-style COMMAND file, set to 1 here to use mc cbl routine
-  linversionout=0
   ohfields_path="../../flexin/"
 
@@ -416,5 +411,5 @@
   !**********************************************************************
 
-  if ((iout.lt.1).or.(iout.gt.5)) then
+  if ((iout.lt.1).or.(iout.gt.6)) then
     write(*,*) ' #### FLEXPART MODEL ERROR! FILE COMMAND:     #### '
     write(*,*) ' #### IOUT MUST BE 1, 2, 3, 4 OR 5 FOR        #### '
@@ -476,14 +471,4 @@
       write(*,*) '#### FOR DOMAIN FILLING RUNS OUTPUT FOR      ####'
       write(*,*) '#### EACH RELEASE IS FORBIDDEN !             ####'
-      stop
-  endif
-
-  ! Inversion output format only for backward runs
-  !*****************************************************************************
-  
-  if ((linversionout.eq.1).and.(ldirect.eq.1)) then
-      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
-      write(*,*) '#### INVERSION OUTPUT FORMAT ONLY FOR        ####'
-      write(*,*) '#### BACKWARD RUNS                           ####'
       stop
   endif
@@ -522,7 +507,7 @@
   !****************************************************************
 
-  if ((ipout.ne.0).and.(ipout.ne.1).and.(ipout.ne.2).and.(ipout.ne.3)) then
+  if ((ipout.ne.0).and.(ipout.ne.1).and.(ipout.ne.2)) then
     write(*,*) ' #### FLEXPART MODEL ERROR! FILE COMMAND:     #### '
-    write(*,*) ' #### IPOUT MUST BE 0, 1, 2 OR 3!             #### '
+    write(*,*) ' #### IPOUT MUST BE 1, 2 OR 3!                #### '
     stop
   endif
Index: src/readpaths.f90
===================================================================
--- src/readpaths.f90	(revision 2eefa58ac797f119acc28fade41beff352006040)
+++ src/readpaths.f90	(revision 62e65c73ae7e3d8c4b8b884065ede76e07211ec8)
@@ -20,5 +20,5 @@
 !**********************************************************************
 
-subroutine readpaths
+subroutine readpaths !(pathfile)
 
   !*****************************************************************************
Index: src/readwind_gfs.f90
===================================================================
--- src/readwind_gfs.f90	(revision 5d74ed914bb3649af12dc589a95068bd49aa0fdb)
+++ src/readwind_gfs.f90	(revision db91eb78afeb1bb8bafe66068877db8841859062)
@@ -83,5 +83,5 @@
 
   ! NCEP
-  integer :: numpt,numpu,numpv,numpw,numprh,numpclwch
+  integer :: numpt,numpu,numpv,numpw,numprh
   real :: help, temp, ew
   real :: elev
@@ -134,5 +134,4 @@
   numpw=0
   numprh=0
-  numpclwch=0
   ifield=0
 10   ifield=ifield+1
@@ -558,20 +557,8 @@
       endif
 ! SEC & IP 12/2018 read GFS clouds
-      if((isec1(6).eq.153).and.(isec1(7).eq.100)) then  !! CLWCR  Cloud liquid water content [kg/kg] 
-         if((i.eq.0).and.(j.eq.0)) then
-            do ii=1,nuvz
-              if ((isec1(8)*100.0).eq.akz(ii)) numpclwch=ii
-            end do
-        endif
-        help=zsec4(nxfield*(ny-j-1)+i+1)
-        if(i.le.i180) then
-          clwch(i179+i,j,numpclwch,n)=help
-        else
-          clwch(i-i181,j,numpclwch,n)=help
-        endif
+      if(isec1(6).eq.153) then  !! CLWCR  Cloud liquid water content [kg/kg]
+        clwch(i,j,nlev_ec-k+2,n)=zsec4(nxfield*(ny-j-1)+i+1)
         readclouds=.true.
         sumclouds=.true.
-!        readclouds=.false.
-!       sumclouds=.false.
       endif
 
Index: src/releaseparticles.f90
===================================================================
--- src/releaseparticles.f90	(revision 7873bf796f5ee67aab272b1243107198ceb275b1)
+++ src/releaseparticles.f90	(revision 75a4dedbe36ebfba4e9c67fce8af8641dafcd8eb)
@@ -114,6 +114,5 @@
       average_timecorrect=0.
       do k=1,nspec
-        if(abs(xpoint2(i)-xpoint1(i)).lt.1.E-4.and.abs(ypoint2(i)-ypoint1(i)).lt.1.E-4) then
-!        if (zpoint1(i).gt.0.5) then      ! point source
+        if (zpoint1(i).gt.0.5) then      ! point source
           timecorrect(k)=point_hour(k,nhour)*point_dow(k,ndayofweek)
         else                             ! area source
Index: src/timemanager.f90
===================================================================
--- src/timemanager.f90	(revision 2eefa58ac797f119acc28fade41beff352006040)
+++ src/timemanager.f90	(revision c7d1052e9b4a8319033f957f6b77184654bca402)
@@ -408,14 +408,5 @@
 #endif
             else
-              if (linversionout.eq.1) then
-                call concoutput_inversion(itime,outnum,gridtotalunc,wetgridtotalunc,drygridtotalunc)
-                if (verbosity.eq.1) then
-                  print*,'called concoutput_inversion'
-                  call system_clock(count_clock)
-                  write(*,*) 'system clock',count_clock - count_clock0 
-                endif
-              else
               call concoutput_surf(itime,outnum,gridtotalunc,wetgridtotalunc,drygridtotalunc)
-              endif
               if (verbosity.eq.1) then
                 print*,'called concoutput_surf '
@@ -431,9 +422,5 @@
                 call concoutput_nest(itime,outnum)
               else 
-                if(linversionout.eq.1) then
-                  call concoutput_inversion_nest(itime,outnum)
-                else 
                 call concoutput_surf_nest(itime,outnum)
-              endif
               endif
             else
@@ -464,8 +451,5 @@
 45      format(i13,' Seconds simulated: ',i13, ' Particles:    Uncertainty: ',3f7.3)
 46      format(' Simulated ',f7.1,' hours (',i13,' s), ',i13, ' particles')
-        if (ipout.ge.1) then
-          if (mod(itime,ipoutfac*loutstep).eq.0) call partoutput(itime) ! dump particle positions
-          if (ipout.eq.3) call partoutput_average(itime) ! dump particle positions
-        endif
+        if (ipout.ge.1) call partoutput(itime)    ! dump particle positions
         loutnext=loutnext+loutstep
         loutstart=loutnext-loutaver/2
@@ -625,10 +609,4 @@
 !        write (*,*) 'advance: ',prob(1),xmass1(j,1),ztra1(j)
 
-  ! Calculate average position for particle dump output
-  !****************************************************
-
-        if (ipout.eq.3) call partpos_average(itime,j)
-
-
   ! Calculate the gross fluxes across layer interfaces
   !***************************************************
@@ -752,11 +730,5 @@
   if (ipout.eq.2) call partoutput(itime)     ! dump particle positions
 
-  if (linit_cond.ge.1) then
-    if(linversionout.eq.1) then
-      call initial_cond_output_inversion(itime)   ! dump initial cond. field
-    else
-      call initial_cond_output(itime)   ! dump initial cond. fielf
-    endif
-  endif
+  if (linit_cond.ge.1) call initial_cond_output(itime)   ! dump initial cond. field
 
   !close(104)
Index: src/timemanager_mpi.f90
===================================================================
--- src/timemanager_mpi.f90	(revision 0c8c7f2f1bd07179b6e1be5a302d9e2d52633f9e)
+++ src/timemanager_mpi.f90	(revision 20963b15051b22eeb381dcf4e824a9104d92717b)
@@ -113,5 +113,5 @@
   integer :: j,ks,kp,l,n,itime=0,nstop,nstop1,memstat=0
 ! integer :: ksp
-  integer :: ip,irec
+  integer :: ip
   integer :: loutnext,loutstart,loutend
   integer :: ix,jy,ldeltat,itage,nage,idummy
@@ -129,5 +129,4 @@
 ! Measure time spent in timemanager
   if (mp_measure_time) call mpif_mtime('timemanager',0)
-
 
 ! First output for time 0
@@ -533,5 +532,5 @@
                 end if
 
-              else
+              else  ! :TODO: check for zeroing in the netcdf module
                 call concoutput_surf_nest(itime,outnum)
               end if
@@ -594,15 +593,8 @@
 46      format(' Simulated ',f7.1,' hours (',i13,' s), ',i13, ' particles')
         if (ipout.ge.1) then
-          if (mp_measure_time) call mpif_mtime('iotime',0)
-          irec=0
           do ip=0, mp_partgroup_np-1
-            if (ip.eq.mp_partid) then
-              if (mod(itime,ipoutfac*loutstep).eq.0) call partoutput(itime) ! dump particle positions
-              if (ipout.eq.3) call partoutput_average(itime,irec) ! dump particle positions
-            endif
-            if (ipout.eq.3) irec=irec+npart_per_process(ip)
+            if (ip.eq.mp_partid) call partoutput(itime) ! dump particle positions
             call mpif_mpi_barrier
           end do
-          if (mp_measure_time) call mpif_mtime('iotime',1)
         end if
 
@@ -765,9 +757,4 @@
         if (mp_measure_time) call mpif_mtime('advance',1)
 
-  ! Calculate average position for particle dump output
-  !****************************************************
-
-        if (ipout.eq.3) call partpos_average(itime,j)
-
 
 ! Calculate the gross fluxes across layer interfaces
@@ -908,5 +895,5 @@
     do ip=0, mp_partgroup_np-1
       if (ip.eq.mp_partid) then 
-        if (mp_dbg_mode) write(*,*) 'call partoutput(itime), proc, mp_partid',ip,mp_partid
+        !if (mp_dbg_mode) write(*,*) 'call partoutput(itime), proc, mp_partid',ip,mp_partid
         call partoutput(itime)    ! dump particle positions
       end if
Index: src/verttransform_ecmwf.f90
===================================================================
--- src/verttransform_ecmwf.f90	(revision 2eefa58ac797f119acc28fade41beff352006040)
+++ src/verttransform_ecmwf.f90	(revision 79e0349a50fd1ee6dfdf4b044ade2b6f1e702855)
@@ -73,4 +73,5 @@
   use com_mod
   use cmapf_mod, only: cc2gll
+!  use mpi_mod
 
   implicit none
@@ -81,6 +82,4 @@
   real,dimension(0:nxmax-1,0:nymax-1,nuvzmax) :: rhoh,uvzlev,wzlev
   real,dimension(0:nxmax-1,0:nymax-1,nzmax) :: pinmconv
-  ! RLT added pressure
-  real,dimension(0:nxmax-1,0:nymax-1,nuvzmax) :: prsh
   real,dimension(0:nxmax-1,0:nymax-1) ::  tvold,pold,pint,tv
   real,dimension(0:nymax-1) :: cosf
@@ -220,4 +219,5 @@
 !*************************
 
+
   do jy=0,nymin1
     do ix=0,nxmin1
@@ -230,6 +230,4 @@
   wzlev(:,:,1)=0.
   rhoh(:,:,1)=pold/(r_air*tvold)
-  ! RLT add pressure
-  prsh(:,:,1)=ps(:,:,1,n)
 
 
@@ -239,6 +237,4 @@
   do kz=2,nuvz
     pint=akz(kz)+bkz(kz)*ps(:,:,1,n)
-    ! RLT add pressure
-    prsh(:,:,kz)=pint
     tv=tth(:,:,kz,n)*(1.+0.608*qvh(:,:,kz,n))
     rhoh(:,:,kz)=pint(:,:)/(r_air*tv)
@@ -292,6 +288,4 @@
   pv(:,:,1,n)=pvh(:,:,1)
   rho(:,:,1,n)=rhoh(:,:,1)
-! RLT add pressure
-  prs(:,:,1,n)=prsh(:,:,1)
 
   uu(:,:,nz,n)=uuh(:,:,nuvz)
@@ -307,6 +301,5 @@
   pv(:,:,nz,n)=pvh(:,:,nuvz)
   rho(:,:,nz,n)=rhoh(:,:,nuvz)
-! RLT
-  prs(:,:,nz,n)=prsh(:,:,nuvz)
+
 
   kmin=2
@@ -328,6 +321,4 @@
           pv(ix,jy,iz,n)=pv(ix,jy,nz,n)
           rho(ix,jy,iz,n)=rho(ix,jy,nz,n)
-! RLT
-          prs(ix,jy,iz,n)=prs(ix,jy,nz,n)
         else
           innuvz: do kz=idx(ix,jy),nuvz
@@ -363,6 +354,4 @@
           pv(ix,jy,iz,n)=(pvh(ix,jy,kz-1)*dz2+pvh(ix,jy,kz)*dz1)/dz
           rho(ix,jy,iz,n)=(rhoh(ix,jy,kz-1)*dz2+rhoh(ix,jy,kz)*dz1)/dz
-! RLT add pressure
-          prs(ix,jy,iz,n)=(prsh(ix,jy,kz-1)*dz2+prsh(ix,jy,kz)*dz1)/dz
         endif
       enddo
@@ -665,5 +654,5 @@
         if ((lsp.gt.0.01).or.(convp.gt.0.01)) then ! cloud and precipitation
 
-          do kz=nz,2,-1 !go Bottom up!
+          do kz=nz,1,-1 !go Bottom up!
             if (clw(ix,jy,kz,n).gt. 0) then ! is in cloud
               cloudsh(ix,jy,n)=cloudsh(ix,jy,n)+height(kz)-height(kz-1) 
Index: src/verttransform_gfs.f90
===================================================================
--- src/verttransform_gfs.f90	(revision 437c545fb9b9ece116fae2e06166d88b979f91a7)
+++ src/verttransform_gfs.f90	(revision db91eb78afeb1bb8bafe66068877db8841859062)
@@ -548,10 +548,10 @@
         if ((lsp.gt.0.01).or.(convp.gt.0.01)) then ! cloud and precipitation
 
-          do kz=nz,2,-1 !go Bottom up!
+          do kz=nz,1,-1 !go Bottom up!
             if (clw(ix,jy,kz,n).gt. 0) then ! is in cloud
               cloudsh(ix,jy,n)=cloudsh(ix,jy,n)+height(kz)-height(kz-1)
               clouds(ix,jy,kz,n)=1                               ! is a cloud
               if (lsp.ge.convp) then
-                clouds(ix,jy,kz,n)=3                             ! lsp in-cloud
+                clouds(ix,jy,kz,n)=3                            ! lsp in-cloud
               else
                 clouds(ix,jy,kz,n)=2                             ! convp in-cloud
